# include "../main/utilities.h"

# include "formula.h"
# include "formulaTest.h"



static std::string name = "formulaFalseTest::";


FormulaFalseTest::TestEquals::TestEquals() : Test() { }


FormulaFalseTest::TestEquals::~TestEquals() { }


bool FormulaFalseTest::TestEquals::runTestAfterFork () {
	return testEquals(); }


bool FormulaFalseTest::TestEquals::testEquals() {
	std::string function = "testEquals:";
	int testNumber = 0;
	bool failed = false;
	FormulaFalse *ref1 = new FormulaFalse();
	FormulaFalse *ref2 = new FormulaFalse();
	FormulaIdentif *ref3 = new FormulaIdentif(0);

    testNumber++;
	if (! (ref1->equals(ref1))) {
		std::cout << name + function << testNumber << " ref1 SHOULD be equal "
			"to itself\n";
		failed = 1; }

    testNumber++;
	if (! (ref1->equals(ref2))) {
		std::cout << name + function << testNumber << " ref1 SHOULD be equal "
			"to ref2\n";
		failed = 1; }

    testNumber++;
	if (ref1->equals(ref3)) {
		std::cout << name + function << testNumber << " ref1 should NOT be "
			"equal to ref3\n";
		failed = 1; }

	ref1->erase();
	ref2->erase();
	ref3->erase();
	return !failed; }


FormulaFalseTest::TestGetValue::TestGetValue() : Test() { }


FormulaFalseTest::TestGetValue::~TestGetValue() { }


bool FormulaFalseTest::TestGetValue::runTestAfterFork () {
	return testGetValue(); }


bool FormulaFalseTest::TestGetValue::testGetValue() {
	std::string function = "testGetValue:";
	int testNumber = 0;
	bool failed = false;
	FormulaFalse *f = new FormulaFalse();

	Assignment *v = new Assignment(1);
    testNumber++;
	if (f->getValue(v) != false) {
		std::cout << name + function << testNumber << " wrong value returned\n";
		failed = 1; }

	v->nextValueSet();
    testNumber++;
	if (f->getValue(v) != false) {
		std::cout << name + function << testNumber << " wrong value returned\n";
		failed = true; }

	f->erase();
	return !failed; }
