# include "../main/utilities.h"

# include "formula.h"
# include "formulaTest.h"



static std::string name = "formulaTrueTest::";


FormulaTrueTest::TestEquals::TestEquals() : Test() { }


FormulaTrueTest::TestEquals::~TestEquals() { }


bool FormulaTrueTest::TestEquals::runTestAfterFork () {
	return testEquals(); }


bool FormulaTrueTest::TestEquals::testEquals() {
	std::string function = "testEquals:";
	int testNumber = 0;
	bool failed = false;
	FormulaTrue *ref1 = new FormulaTrue();
	FormulaTrue *ref2 = new FormulaTrue();
	FormulaIdentif *ref3 = new FormulaIdentif(0);

    testNumber++;
	if (! (ref1->equals(ref1))) {
		std::cout << name + function << testNumber << " ref1 SHOULD be equal "
			"to itself\n";
		failed = true; }

    testNumber++;
	if (! (ref1->equals(ref2))) {
		std::cout << name + function << testNumber << " ref1 SHOULD be equal "
			"to ref2\n";
		failed = true; }

    testNumber++;
	if (ref1->equals(ref3)) {
		std::cout << name + function << testNumber << " ref1 should NOT be "
			"equal to ref3\n";
		failed = true; }

	ref1->erase();
	ref2->erase();
	ref3->erase();
	return !failed; }


FormulaTrueTest::TestGetValue::TestGetValue() : Test() { }


FormulaTrueTest::TestGetValue::~TestGetValue() { }


bool FormulaTrueTest::TestGetValue::runTestAfterFork () {
	return testGetValue(); }


bool FormulaTrueTest::TestGetValue::testGetValue() {
	std::string function = "testGetValue:";
	int testNumber = 0;
	bool failed = false;
	FormulaTrue *t = new FormulaTrue();

	Assignment *v = new Assignment(1);
    testNumber++;
	if (t->getValue(v) != true) {
		std::cout << name + function << testNumber << " wrong value returned\n";
		failed = true; }

	v->nextValueSet();
    testNumber++;
	if (t->getValue(v) != true) {
		std::cout << name + function << testNumber << " wrong value returned\n";
		failed = true; }

	t->erase();
	return !failed; }
