# include "utilities.h"

# include "../test/fullTest.h"
# include "main.h"
# include "formulaCalc.h"



int main (int argc, char *argv[]) {
	if (argc == 1) {
		std::cout << "Missing parameters to run." << std::endl <<
		"Recur to the readme.txt file for more information" << std::endl;
		utilitiesPause(); }

	for (int i = 1; i < argc; i++) if (argv[i][0] == '-') {
		readParameter(argv[i]); }

	setOutFile("");
	return 0; }


void readParameter (char *parameter) {
	switch (parameter[1]) {
		case 'm':
			if ('0' <= parameter[2] && parameter[2] <= '1') {
			setMethod((int)(parameter[2]-'0')); }
			break;
		case 'n':
			if ('0' <= parameter[2] && parameter[2] <= '9') {
			setSilence((int)(parameter[2]-'0')); }
			break;
		case 't':
			runTests();
			return;
		case 'p':
			utilitiesPause();
			return;
		case 'v': {
			processCommand(new std::string(parameter+2));
			return; }
		case 'f':
			processFile(parameter+2);
			return;
		case 'o':
			setOutFile(parameter+2);
			return;
		case 's':
			runStepExec();
			return;
		default:
			if (getSilence() < 9) {
				std::cout << "parameter not understood" << std::endl; }}}


void runTests() {
	FullTest *tests = new FullTest();

	if (getSilence() < 5) {
		std::cout << "running tests..." << std::endl; }
	tests->runTest();

	if (getSilence() < 5) {
		tests->print(); }
	delete tests; }


void runStepExec() {
	char c = 'n';

	std::cout << "beginnig step-by-step execution" << std::endl;
	while (true) {
		std::cout << "Type a command: ";
		scanf(" %c", &c);

		switch (c) {
			case 'q':
				std::cout << "quitting step-by-step execution" << std::endl;
				return;
			case 'd':
				switchDebugging();
				if (isDebugging()) std::cout << "debug activated" << std::endl;
				else std::cout << "debug deactivated" << std::endl;
				break;
			default:
				std::cout << "command not understood" << std::endl; }}}


void processFile(char *parameter) {
	std::ifstream in;
	std::string nextLine = "", *command;

	in.open (parameter);
	if (!in.is_open()) {
		if (getSilence() < 5) {
	        std::cout << "Unable to open file" << std::endl << std::endl; }
        return; }

	getNextCommand(in, nextLine);
	while (!in.eof()) processCommand (getNextCommand(in, nextLine));

	in.close();
	return; }



void processCommand (std::string* command) {
	if (getSilence() < 2) {
		std::cout << *command << std::endl; }
	Parser *p = new Parser(*command);
	
	if (isTableMethodInUse()) {
		delete p;
		table = new FormulaTable();
		p = new ParserTable(*command); }

	clock_t start = clock(), end;
	resetMaxFormulas();
	calcFormula(p->parse(), p->getMap());

	if (getOutFile()->is_open()) {
		end = clock();
        (*getOutFile()) << "Formula computed. Structures used:" <<
			getMaxFormulas() << " ,time quantity: " << end-start << std::endl; }

	std::cout << std::endl;
	delete p;
	if (isTableMethodInUse()) delete table;
	delete command; }



std::string* getNextCommand(std::ifstream &in, std::string &lineAhead) {
	std::string *command = new std::string("");
	unsigned lenght;

	do {
		lenght = command->size();
		if (lenght > 0 && (command->at(lenght-1) == '\n'
			|| command->at(lenght-1) == '\0')) {
			command->replace(lenght-1,1," "); }

		(*command) += lineAhead;
		getline (in,lineAhead);
		if (lineAhead.size() > 1 && lineAhead[0] == '\\' &&
				lineAhead[1] == '>') {
			lineAhead.replace(0,2,"  ");
			break; }}
	while (!in.eof());

	return command; }
