# include <cstdlib>
# include "../main/utilities.h"

# include "IDmap.h"



Map::Map() {
	elementList = new std::vector<std::string *>(); }



Map::~Map() {
	delete elementList; }


		
/*
 * Returns the current number of IDs registered in this map.
 */
int Map::numberOfElements() {
	return elementList->size(); }



/*
 * @param element: the identifier queried.
 * Returns true if this map contains @element. Returns false otherwise.
 *
 * Note: @element isn't added to the map.
 */
bool Map::contains (std::string *element) {
	if (search(element) == -1) return false;
	return true; }



/*
 * @param element: the identifier queried.
 * Returns the ID of the requested @element.
 *
 * Note: if the identifier isn't present in this map, It is added.
 */
int Map::getValue (std::string *element) {
	int i = search(element);

	if (i > -1) return i;

	add(element);
	return numberOfElements()-1; }



/*
 * @param index: the ID required.
 * Returns the identifier mapped by the requested ID.
 */
std::string* Map::getElement (int index) {
	if (index < 0 || index >= (signed) elementList->size()) return NULL;
	return (*elementList)[index]; }



/*
 * @param element: the identifier queried.
 * Returns the ID of the requested @element, if possible. Returns -1
 * otherwise.
 *
 * Note: @element isn't added to the map.
 */
int Map::search (std::string *element) {
	for (int i = 0; i < numberOfElements(); i++) {
		if (*element == *((*elementList)[i])) return i; }

	return -1; }



/*
 * @param element: the identifier to be added.
 * Adds @element to this map.
 */
void Map::add (std::string *element) {
	elementList->push_back(new std::string(*element)); }
