# include "../main/utilities.h"
# include "assignment.h"



/*
 * @param elements: the number of ID to be assigned.
 */
Assignment::Assignment(int elements) {
	this->elements = elements;
	elementList = new std::vector<bool>(elements);

	while (elements > 0) {
		elements--;
		(*elementList)[elements] = false; }}



Assignment::~Assignment() {
	delete elementList; }



/*
 * Returns the number of ID that are being assigned.
 */
int Assignment::numberOfElements() {
	return elements; }



/*
 * @param value: the value to be assigned.
 * @param ID: the ID to receive the required value
 * Assigns @value to the ID @ID.
 */
void Assignment::setValue (bool value, int ID) {
	if (ID >= 0 && ID < elements) (*elementList)[ID] = value; }



/*
 * @param ID: the ID queried.
 * Returns the value assigned to the ID @ID.
 */
bool Assignment::getValue (int ID) {
	if (ID >= 0 && ID < elements) return (*elementList)[ID];
	return false; }



/*
 * Sets all IDs to a new assignment.
 *
 * Note: when created, this instance assigns false to all IDs. If this
 *      function is used until all IDs are assigned to true, then it's
 *      garanteed that all possible combinations have been assigned.
 */
void Assignment::nextValueSet() {
	for (int i = 0; i < elements; i++) {
		if ((*elementList)[i] == true) (*elementList)[i] = false;
		else {
			(*elementList)[i] = true;
			return; }}}



/*
 * Returns true if all IDs are assigned to true. Returns false otherwise
 */
bool Assignment::isAllValuesTrue() {
	for (int i = 0; i < elements; i++) {
		if ((*elementList)[i] == false) return false; }

	return true; }
