# include "../main/utilities.h"

# include "assignment.h"
# include "assignmentTest.h"



static std::string name = "assignmentTest::";


AssignmentTest::AssignmentTest() : TestSuite() {
	addTest(new TestAssignmentGetAndSet());
	addTest(new TestNextValueSet()); }


AssignmentTest::~AssignmentTest() { }


AssignmentTest::TestAssignmentGetAndSet::TestAssignmentGetAndSet() : Test() { }


AssignmentTest::TestAssignmentGetAndSet::~TestAssignmentGetAndSet() { }


bool AssignmentTest::TestAssignmentGetAndSet::runTestAfterFork () {
	return testAssignmentGetAndSet(); }


bool AssignmentTest::TestAssignmentGetAndSet::testAssignmentGetAndSet() {
	std::string function = "testAssignmentGetAndSet:";
	int testNumber = 0;
	bool failed = false;
	Assignment *v = new Assignment(2);

    testNumber++;
	if (!failed && v->getValue(0) != false) {
		std::cout << name + function << testNumber << " wrong initial value\n";
		failed = true; }

    testNumber++;
	if (!failed && v->getValue(1) != false) {
		std::cout << name + function << testNumber << " wrong initial value\n";
		failed = true; }

	v->setValue(true, 0);
    testNumber++;
	if (!failed && v->getValue(0) != true) {
		std::cout << name + function << testNumber << " value was not set to "
			"true\n";
		failed = true; }

    testNumber++;
	if (!failed && v->getValue(1) != false) {
		std::cout << name + function << testNumber << " value changed "
			"improperly\n";
		failed = true; }

	v->setValue(false, 0);
    testNumber++;
	if (!failed && v->getValue(0) != false) {
		std::cout << name + function << testNumber << " value was not set to "
			"false\n";
		failed = true; }

	delete v;
	return !failed; }



AssignmentTest::TestNextValueSet::TestNextValueSet() : Test() { }


AssignmentTest::TestNextValueSet::~TestNextValueSet() { }


bool AssignmentTest::TestNextValueSet::runTestAfterFork () {
	return testNextValueSet(); }


bool AssignmentTest::TestNextValueSet::testNextValueSet() {
	std::string function = "testNextValueSet:";
	int testNumber = 0;
	bool failed = false;
	Assignment *v = new Assignment(2);

    testNumber++;
	if (!failed && (v->getValue(0) != false || v->getValue(1) != false)) {
		std::cout << name + function << testNumber << " wrong initial value\n";
		failed = true; }

	v->nextValueSet();
    testNumber++;
	if (!failed && (v->getValue(0) != true || v->getValue(1) != false)) {
		std::cout << name + function << testNumber << " wrong next value set\n";
		failed = true; }

	v->nextValueSet();
    testNumber++;
	if (!failed && (v->getValue(0) != false || v->getValue(1) != true)) {
		std::cout << name + function << testNumber << " wrong next value set\n";
		failed = true; }

	v->nextValueSet();
    testNumber++;
	if (!failed && (v->getValue(0) != true || v->getValue(1) != true)) {
		std::cout << name + function << testNumber << " wrong next value set\n";
		failed = true; }

	delete v;
	return !failed; }
