# include "../main/utilities.h"

# include "IDmap.h"
# include "mapTest.h"



static std::string name = "mapTest::";


MapTest::MapTest() : TestSuite() {
	addTest(new TestEmptyMap());
	addTest(new TestQueryAndAdd());
	addTest(new TestGetValue()); }


MapTest::~MapTest() { }


MapTest::TestEmptyMap::TestEmptyMap() : Test() { }


MapTest::TestEmptyMap::~TestEmptyMap() { }


bool MapTest::TestEmptyMap::runTestAfterFork () {
	return testEmptyMap(); }


bool MapTest::TestEmptyMap::testEmptyMap() {
	std::string function = "testEmptyMap:";
	int testNumber = 0;
	int failed = 0;
	Map *ref = new Map();
	std::string s = "";

    testNumber++;
	if (ref->numberOfElements() != 0) {
		std::cout << name + function << testNumber << " wrong number of "
			"initial elements\n";
		failed = true; }

    testNumber++;
	if (ref->contains(&s)) {
		std::cout << name + function << testNumber << " an empty map should "
			"not contain anything\n";
		failed = true; }

	s = "x";
    testNumber++;
	if (ref->contains(&s)) {
		std::cout << name + function << testNumber << " an empty map should "
			"not contain anything\n";
		failed = true; }

	s = "123";
    testNumber++;
	if (ref->contains(&s)) {
		std::cout << name + function << testNumber << " an empty map should "
			"not contain anything\n";
		failed = true; }

	s = "abc";
    testNumber++;
	if (ref->contains(&s)) {
		std::cout << name + function << testNumber << " an empty map should "
			"not contain anything\n";
		failed = true; }

	s = "y";
    testNumber++;
	if (ref->contains(&s)) {
		std::cout << name + function << testNumber << " an empty map should "
			"not contain anything\n";
		failed = true; }

	delete ref;
	return !failed; }


MapTest::TestQueryAndAdd::TestQueryAndAdd() : Test() { }


MapTest::TestQueryAndAdd::~TestQueryAndAdd() { }


bool MapTest::TestQueryAndAdd::runTestAfterFork () {
	return testQueryAndAdd(); }


bool MapTest::TestQueryAndAdd::testQueryAndAdd() {
	std::string function = "testEmptyMap:";
	int testNumber = 0;
	bool failed = false;
	Map *ref = new Map();
	std::string s = "x";

    testNumber++;
	if (ref->contains(&s)) {
		std::cout << name + function << testNumber << " x should NOT be in "
			"the map now\n";
		failed = true; }

	s = "y";
    testNumber++;
	if (ref->contains(&s)) {
		std::cout << name + function << testNumber << " y should NOT be in "
			"the map now\n";
		failed = true; }

	s = "x";
	ref->getValue(&s);

    testNumber++;
	if (!(ref->contains(&s))) {
		std::cout << name + function << testNumber << " x SHOULD be in the "
			"map now\n";
		failed = true; }

	s = "y";
    testNumber++;
	if (ref->contains(&s)) {
		std::cout << name + function << testNumber << " y should NOT be in "
			"the map now\n";
		failed = true; }

	ref->getValue(&s);

	s = "x";
    testNumber++;
	if (!(ref->contains(&s))) {
		std::cout << name + function << testNumber << " x SHOULD be in the "
			"map now\n";
		failed = true; }

	s = "y";
    testNumber++;
	if (!(ref->contains(&s))) {
		std::cout << name + function << testNumber << " y SHOULD be in the "
			"map now\n";
		failed = true; }

	delete ref;
	return !failed; }


MapTest::TestGetValue::TestGetValue() : Test() { }


MapTest::TestGetValue::~TestGetValue() { }


bool MapTest::TestGetValue::runTestAfterFork () {
	return testGetValue(); }


bool MapTest::TestGetValue::testGetValue() {
	std::string function = "testGetValue:";
	int testNumber = 0;
	bool failed = false;
	Map *ref = new Map();
	int xValue, yValue, zValue;
	std::string sx = "x";
	std::string sy = "y";
	std::string sz = "z";

	xValue = ref->getValue(&sx);
	yValue = ref->getValue(&sy);

    testNumber++;
	if (xValue == yValue) {
		std::cout << name + function << testNumber << " x and y has the same "
			"value\n";
		failed = true; }

    testNumber++;
	if (xValue != ref->getValue(&sx)) {
		std::cout << name + function << testNumber << " x value has changed\n";
		failed = true; }

	zValue = ref->getValue(&sz);

    testNumber++;
	if (xValue == yValue) {
		std::cout << name + function << testNumber << " x and y has the same "
			"value\n";
		failed = true; }

    testNumber++;
	if (zValue == yValue) {
		std::cout << name + function << testNumber << " z and y has the same "
			"value\n";
		failed = true; }

    testNumber++;
	if (xValue == zValue) {
		std::cout << name + function << testNumber << " x and z has the same "
			"value\n";
		failed = true; }

    testNumber++;
	if (xValue != ref->getValue(&sx)) {
		std::cout << name + function << testNumber << " x value has changed\n";
		failed = true; }

    testNumber++;
	if (yValue != ref->getValue(&sy)) {
		std::cout << name + function << testNumber << " y value has changed\n";
		failed = true; }

	delete ref;
	return !failed; }
